{-# LANGUAGE BangPatterns #-}

import Prelude hiding (read, catch)

-- import LogParser
import Data.Maybe
import Text.Printf
import Text.Regex.TDFA
import KoL.Util
import Data.List
import Network.URI
import qualified Codec.Compression.BZip
import qualified Data.ByteString.Lazy.Char8
import qualified Database.SQLite3
import Data.IORef
import System
import System.IO
import Control.Applicative
import Control.Exception
import Data.Time.Clock

import Text.JSON

data LogPageload = LogPageload {
	logidx :: !Integer,
	uri :: !URI,
	effuri :: !URI,
-- 	title :: Maybe String,
	turn_before :: !Integer,
	turn_after :: !Integer,
	ascensionday :: !Integer,
-- 	rolloverbefore :: Integer,
	zonename :: !String,
	zonecontainer :: !String,
-- 	allparams :: [(String, String)],
	stats_before :: !(Integer, Integer, Integer),
	stats_after :: !(Integer, Integer, Integer),
	trail_before :: !Bool,
	trail_after :: !Bool
} deriving (Show)

parse_page_title pagetext =
	case (pagetitle, monstername, advrestitle) of
		(_, [[x]], _) -> Just $ x
		(_, _, [[x]]) -> Just $ x
		([["Results:"]], _, _) -> Nothing
		([["Adventure Results:"]], _, _) -> Nothing
		([[x]], _, _) -> Just $ x
		_ -> Nothing
	where
		pagetitle = matchGroups "<tr><td style=\"color: white;\" align=center bgcolor=blue><b>([^<]+)</b></td></tr>" pagetext
		monstername = matchGroups ">You're fighting <span id='monname'>([^<]*)</span><" pagetext
		advrestitle = matchGroups "<td style=\"color: white;\" align=center bgcolor=blue><b>[a-zA-Z]* Results:</b></td></tr><tr><td style=\"padding: 5px; border: 1px solid blue;\"><center><table><tr><td><center><b>([^<]*)</b>" pagetext

time_it _msg x = x

-- time_it msg x = do
-- 	t_before <- getCurrentTime
-- 	!y <- x
-- 	t_after <- getCurrentTime
-- 	putStrLn $ msg ++ ": " ++ (show $ diffUTCTime t_after t_before)
-- 	return y

-- TODO! catch the ireallymeanit!


-- 	import Text.XML.HXT.Core

-- 	make_ascension_xmltree :: ArrowXml a => String -> String -> Integer -> [(Integer, [(String, String, String, URI)])] -> a XmlTree XmlTree
-- 	make_ascension_xmltree charname charclass ascnum ascensiondata =
-- 			mkelem "ascensionlogxml" [ sattr "version" "kolproxy-test-0.1a" ] [
-- 	-- 			mkelem "ascension" [ sattr "charactername" charname, sattr "characterclass" charclass, sattr "ascensionnumber" (show ascnum) ] (map day_mapf ascensiondata)
-- 				mkelem "ascension" [] (map day_mapf ascensiondata)
-- 			]
-- 		where
-- 			day_mapf (day, encounters) = mkelem "day" [ sattr "daynumber" (show day) ] (map encounter_mapf encounters)
-- 			encounter_mapf (enctype, name, status, url) =
-- 				mkelem "encounter" [ sattr "encountertype" enctype, sattr "encountername" name, sattr "encounterurl" (show url) ] [
-- 					mkelem "status" [ sattr "statustype" "json" ] [ txt status ]
-- 				]


-- if it's a fight.php, then backtrack until effective is a fight.php and requested isn't
-- if it's a choice.php, then backtrack until effective is a choice.php and requested isn't

-- recurse_urls = ["/fight.php", "/choice.php"]

-- TODO: whitelist ones that can be passed through instead of blacklist?
-- process_reverse_group :: [LogPageload] -> Maybe String -> [LogPageload] -> [LogPageload] -> ([LogPageload], [LogPageload])
-- process_reverse_group [] _ buildup orig = error $ "ran out of group urls to process" ++ (show $ map debug_line buildup) ++ " from " ++ (show $ map debug_line orig)
-- process_reverse_group (x:xs) target buildup orig
-- 		| (target == Nothing) =
-- 			if ret `elem` recurse_urls
-- 				then process_reverse_group (x:xs) (Just ret) buildup orig
-- 				else ([x] ++ buildup, xs)
-- 		| (ret == "/inv_use.php") = ([x] ++ buildup, xs)
-- 		| (ret == "/hiddencity.php") = ([x] ++ buildup, xs)
-- 		| (ret == "/fight.php" && it_is_ed) = ([x] ++ buildup, xs)
-- 		| (Just ret /= target) = process_reverse_group xs target buildup orig
-- 		| (Just req == target) = process_reverse_group xs target ([x] ++ buildup) orig
-- 		| (req `elem` recurse_urls) = process_reverse_group (x:xs) (Just req) ([x] ++ buildup) orig
-- 		| otherwise = ([x] ++ buildup, xs)
-- 	where
-- 		req = uriPath $ uri $ x
-- 		ret = uriPath $ effuri $ x
-- 		it_is_ed = case title x of
-- 			Just y -> y =~ "Ed the Undying"
-- 			_ -> False

-- process_group xs = process_reverse_group (reverse xs) Nothing [] xs

-- takestr_upto _ [] = []
-- takestr_upto 0 _l = "..."
-- takestr_upto n (h:t) = h:(takestr_upto (n-1 :: Integer) t)
	
-- debug_line x = (title x, uri x, uriPath $ effuri $ x, turnbefore x, turnafter x, title x, takestr_upto 20 $ show $ allparams x)

format_number_range from to
	| (from == to) = "#"
	| (from == to - 1) = show from
	| (from < to) = (show $ from) ++ "-" ++ (show $ to - 1)

-- TODO: BAD! can only detect sniffs on fights that take turns now!! also, other stuff!
-- hmm, really?
-- did_we_sniff [] = Nothing
-- did_we_sniff (x:xs)
-- 	| (trail_before x == False && trail_after x == True) = Just " => Sniffed!"
-- 	| (trail_before x == True && trail_after x == False) = Just " => /end-of-sniff"
-- 	| otherwise = did_we_sniff xs

-- get_monster_for_item_use [] = Nothing
-- get_monster_for_item_use (x:xs)
-- 		| (to == "/fight.php") = Just $ "item use -> " ++ (fromJust $ title x)
-- 		| otherwise = get_monster_for_item_use xs
-- 	where
-- 		to = uriPath $ effuri $ x
	

-- get_source from to title g
-- 		| (from == "/inv_use.php" && to == "/fight.php") = case get_monster_for_item_use g of
-- 			Just x -> Just x
-- 			_ -> Just other
-- 		| otherwise = Just other
-- 	where
-- 		other = "{ page: " ++ from ++ " } | DEBUG: " ++ (show $ map debug_line g)

-- get_noturn_things x
-- 		| (req == "/fight.php" || req == "/choice.php") = Nothing
-- 		| (ret == "/choice.php" && isJust (title x)) = Just (fromJust $ title x, [x], "(%s)")
-- 		| (ret == "/fight.php" && isJust (title x)) = Just (fromJust $ title x, [x], "(%s)")
-- 		| (ret == "/adventure.php" && isJust (title x)) = Just (fromJust $ title x, [x], "(%s)")
-- 		| otherwise = Nothing
-- 	where
-- 		req = uriPath $ uri $ x
-- 		ret = uriPath $ effuri $ x
-- 		tbefore = turnbefore x
-- 		tafter = turnafter x

-- do_turn_group rawg =
-- 		(reverse $ mapMaybe get_noturn_things g_rest) ++ (maybeToList $ if tbefore < tafter
-- 			then Just $ case (title $ head g, source) of
-- 				(Just t, _) -> (t, g, "[%s]")
-- 				(_, Just s) -> (s, g, "{%s}")
-- 				_ -> (printf "(%s -> %s)" from to, g, "??? %s ???")
-- 			else Nothing) ++ (case did_we_sniff g of
-- 				Just x -> [(x, g, "*%s*")]
-- 				_ -> [])
-- 	where
-- 		(g, g_rest) = process_group rawg
-- 		tbefore = turnbefore (head g)
-- 		tafter = turnafter (last g)
-- 		from = uriPath $ uri $ head g
-- 		to = uriPath $ effuri $ last g
-- 		source = get_source from to title g

-- 		readpostparams = case postparams of
-- 			Nothing -> Nothing
-- 			Just pstr -> read_as pstr :: Maybe [(String, String)]

getstatus jscombinedstr = jso where
	Ok jscombobj = decodeStrict jscombinedstr :: Result (JSObject JSValue)
	Ok jso = valFromObj "status" jscombobj :: Result (JSObject JSValue)

get_value name jsobj = x where
	Just (JSString jsstr) = lookup name $ fromJSObject jsobj
	!x = fromJSString jsstr

get_value_int name jsobj = case valFromObj name jsobj of
	Ok (JSString s) -> Just jss where
		Just !jss = read_as (fromJSString s)
	Ok (JSRational _ r) -> Just rounded where
		!rounded = round r
	Ok JSNull -> Just 0 -- HACK for when rollover is broken and not set yet
	_ -> Nothing

isontrail jsobj = case valFromObj "effects" jsobj :: Result (JSObject JSValue) of
	Ok effectsobj -> isJust $ lookup "91635be2834f8a07c8ff9e3b47d2e43a" $ fromJSObject effectsobj
	_ -> False

build_thing lidx requri returi jsbefore jsafter __raw_row_cols = do
	if get_value_int "freedralph" jsbefore == Just 1
		then return Nothing
		else (do
			let Ok lastadvobjafter = valFromObj "lastadv" jsafter
			let getstats jsobj = (fromJust $ get_value_int "rawmuscle" jsobj, fromJust $ get_value_int "rawmysticality" jsobj, fromJust $ get_value_int "rawmoxie" jsobj)
			let !thing = LogPageload {
				logidx = fromJust $ read_as $ lidx,
				uri = requri,
				effuri = returi,
				turn_before = (fromJust $ get_value_int "turnsthisrun" jsbefore) + 1,
				turn_after = (fromJust $ get_value_int "turnsthisrun" jsafter) + 1,
				ascensionday = case get_value_int "daysthisrun" jsbefore of
					Just d -> d
					_ -> fromJust $ get_value_int "rollover" jsbefore,
				zonename = get_value "name" lastadvobjafter,
				zonecontainer = get_value "container" lastadvobjafter,
				stats_before = getstats jsbefore,
				stats_after = getstats jsafter,
				trail_before = isontrail jsbefore,
				trail_after = isontrail jsafter
			}
			let !__l = length $ show $ thing
			return $ Just thing) `catch` (\e -> do
					putStrLn $ "Error parsing row: " ++ show lidx ++ ": " ++ show (e :: SomeException)
					putStrLn $ "  contents: " ++ show __raw_row_cols
					return Nothing)

go_build_thing __raw_row_cols@[lidx, requestedurlstr, retrievedurlstr, statusbeforestr, statusafterstr] = do
	let Just requri = parseURIReference requestedurlstr
	let Just returi = parseURIReference retrievedurlstr
	let !jsbefore = getstatus statusbeforestr
	let !jsafter = getstatus statusafterstr
	build_thing lidx requri returi jsbefore jsafter __raw_row_cols

getresults s acc = do
	sr <- Database.SQLite3.step s
	case sr of
		Database.SQLite3.Row -> do
			[Database.SQLite3.SQLInteger lidx, Database.SQLite3.SQLText requestedurlstr, Database.SQLite3.SQLText retrievedurlstr, Database.SQLite3.SQLText statusbeforestr, Database.SQLite3.SQLText statusafterstr] <- Database.SQLite3.columns s
			newthing <- time_it ("row:" ++ show lidx) $ go_build_thing [show lidx, requestedurlstr, retrievedurlstr, statusbeforestr, statusafterstr]
			case newthing of
				Just x -> getresults s (x:acc)
				_ -> getresults s acc
		Database.SQLite3.Done -> return acc

scan_through_database filename = do
	log_db <- Database.SQLite3.open filename
	rsgood <- do
		s <- Database.SQLite3.prepare log_db "SELECT idx, requestedurl, retrievedurl, statusbefore, statusafter FROM pageloads;"
		r <- reverse <$> getresults s []
		Database.SQLite3.finalize s
		return r

	putStrLn $ filename ++ " length rsgood: " ++ (show $ length $ rsgood)

	let group_by_day x y = ascensionday x == ascensionday y
	let group_by_container x y = zonecontainer x == zonecontainer y
	let group_by_zone x y = zonename x == zonename y
	let group_by_turn x y = turn_before x == turn_before y
	let format_turn_range format xs =
			"<span class=\"turnrange inside\">" ++ (printf format tstr) ++ "</span>"
		where
			tstr = format_number_range from to
			from = turn_before (head xs)
			to = turn_after (last xs)
	let desc_statgain xs = printf "(%+d mus, %+d mys, %+d mox)" (samus - sbmus) (samys - sbmys) (samox - sbmox) :: String
		where
			(sbmus, sbmys, sbmox) = stats_before (head xs)
			(samus, samys, samox) = stats_after (last xs)
	let do_line parentheader (a, b, c) = return $ printf "%s %s" (format_turn_range c b) (concat parentheader ++ a) :: IO String
	let do_turn parentheader xs = do
		--mapM (\x -> do_line parentheader x) $ do_turn_group xs
		[[Just pagetext]] <- do_db_query log_db "SELECT pagetext FROM pageloads WHERE idx = ?;" [Just $ show $ logidx $ last xs]
		!y <- do_line parentheader $ (case parse_page_title pagetext of
			Just z -> z
			_ -> "??? " ++ (uriPath $ effuri $ last $ xs) ++ " ???", xs, "(%s)")
-- 		putStrLn y
		return $ if (turn_before $ head $ xs) == (turn_after $ last $ xs)
			then []
			else [y ++ "<br>\n"]

	zdivnamecounter <- newIORef (1 :: Integer)
	cdivnamecounter <- newIORef (1 :: Integer)
	ddivnamecounter <- newIORef (1 :: Integer)

	let do_level shortname do_sub namecounter group_method headliner parentheader xs = do
		let sn = shortname
		xid <- readIORef namecounter
		writeIORef namecounter (xid + 1)
		let subxs = groupBy group_method xs
		let desc = printf "%s %s" (format_turn_range "[%s]" xs) (concat parentheader ++ headliner xs) :: String
		subret <- mapM (\x -> do_sub [] x) subxs
		subret <- return $ concat subret
		case subret of
			[] -> do
				ret <- return $ []
				ret <- return $ (++) ret $ printf "<div id=\"%s%d\" class=\"%s\">\n" sn xid sn
				ret <- return $ (++) ret $ printf "%s %s<br>\n" desc (desc_statgain xs)
				ret <- return $ (++) ret $ "</div>\n"
				return [ret]
			[sr] -> return [sr]
			_ -> do
				ret <- return $ []
				ret <- return $ (++) ret $ printf "<div id=\"%s%d\" class=\"%s\">\n" sn xid sn
				ret <- return $ (++) ret $ printf "%s %s <a href=\"#\" onclick=\"return toggle(this, %sd%d);\" class=\"expander\">[+]</a><br>\n" desc (desc_statgain xs) sn xid
				ret <- return $ (++) ret $ printf "  <div id=\"%sd%d\" class=\"details\">\n" sn xid
				ret <- return $ ret ++ (concat subret)
				ret <- return $ (++) ret $ "  </div>\n"
				ret <- return $ (++) ret $ "</div>\n"
				return [ret]

	let do_zone = do_level "z" do_turn zdivnamecounter group_by_turn (\xs -> zonename $ head $ xs)
	let do_container = do_level "c" do_zone cdivnamecounter group_by_zone (\xs -> zonecontainer $ head $ xs)
	let do_day = do_level "d" do_container ddivnamecounter group_by_container (\xs -> printf "Day %d" $ ascensionday $ head $ xs :: String)

	all_lines <- mapM (\x -> do_day [] x) $ groupBy group_by_day rsgood

	let header_html = [
		"<html>",
		"<head>",
		"  <style>",
		"    body { font-family: monospace; }",
		"    .expander { color: green; }",
		"    .turnrange { color: blue; }",
		"    .z .details .turnrange { color: darkcyan; }",
		"    .inside { min-width: 12em; }",
		"    .details { margin-left: 20px; color: dimgray; display: none; }",
		"  </style>",
		"  <script type=\"text/javascript\">",
		"    function toggle(t, id) {",
		"      if (id.style.display == 'block') {",
		"        t.innerHTML = '[+]'",
		"        id.style.display = 'none'",
		"        return false",
		"      } else {",
		"        t.innerHTML = '[-]'",
		"        id.style.display = 'block'",
		"        return false",
		"      }",
		"    }",
		"  </script>",
		"</head>",
		"<body>"]

	let footer_html = [
		"</body>",
		"</html>"]

	let ret = header_html ++ (concat all_lines) ++ footer_html
-- 	let ret = []

	Database.SQLite3.close log_db
	return ret

process_file filename = do
	putStrLn $ "processing " ++ filename
	withBinaryFile "temp-logparse-file.sqlite3" WriteMode $ \handle_out -> do
		withBinaryFile filename ReadMode $ \handle_in -> do
			(if filename =~ ".bz2$" then Codec.Compression.BZip.decompress else id) <$> Data.ByteString.Lazy.Char8.hGetContents handle_in >>= Data.ByteString.Lazy.Char8.hPut handle_out
	putStrLn $ "parsing temp version of " ++ filename
	lines <- scan_through_database "temp-logparse-file.sqlite3"
	mapM_ putStrLn lines
	putStrLn $ "processing done!"

main = do
	hSetBuffering stdout LineBuffering
	args <- getArgs
	case args of
		[filename] -> process_file filename
		_ -> putStrLn $ "Usage: log_parser Eleron-168.ascension-log.sqlite3"


-- 			scan_through_database filename
-- 					contents <- if filename =~ ".bz2$"
-- 						then do
-- 							compressed_contents <- Data.ByteString.Lazy.Char8.readFile filename
-- 							return $ Data.ByteString.Lazy.Char8.unpack $ Codec.Compression.BZip.decompress compressed_contents
-- 						else readFile filename
-- 		-- 			make_into_database contents
-- 					parsed <- parse_log contents
-- 		-- 			mapM putStrLn parsed
-- 		-- 				(charname, charclass, ascnum, ascensiondata) <- parse_log_xml contents
-- 		-- 				let xmltree = make_ascension_xmltree charname charclass ascnum ascensiondata
-- 		-- 				[xmlstr] <- runX ((root [] [xmltree]) >>> (writeDocumentToString [withIndent yes]))
-- 		-- 	-- 			putStrLn xmlstr
-- 		-- 				h <- openFile "ascensionlog-xml-test.bz2" WriteMode
-- 		-- 				let compressed_contents = Codec.Compression.BZip.compress (Data.ByteString.Lazy.Char8.pack xmlstr)
-- 		-- 				Data.ByteString.Lazy.Char8.hPut h compressed_contents
-- 		-- 				hClose h
-- 					return ()

-- main = do
-- 	scan_through_database
-- 	return ()

